(function() {"use strict";var __module = CC_EDITOR ? module : {exports:{}};var __filename = 'preview-scripts/assets/scripts/Scene.js';var __require = CC_EDITOR ? function (request) {return cc.require(request, require);} : function (request) {return cc.require(request, __filename);};function __define (exports, require, module) {"use strict";
cc._RF.push(module, '0548e883YtICbHN1xH6o0xs', 'Scene', __filename);
// scripts/Scene.ts

Object.defineProperty(exports, "__esModule", { value: true });
var Airplane_1 = require("./Airplane");
var _a = cc._decorator, ccclass = _a.ccclass, property = _a.property;
var Scene = /** @class */ (function (_super) {
    __extends(Scene, _super);
    function Scene() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.AirplanePrefab = null;
        _this.zhunxinPrefab = null;
        _this.sky = null;
        _this.bullet = null;
        _this.round = null;
        _this.airplaneList = [];
        _this.bulletDirection = 1;
        _this.bulletRotationSpeed = 45;
        _this.bulletRotationMax = 140;
        _this.airplaneMoveSpeed = 50;
        _this.airplaneAddSpeed = 2;
        _this.airAddTime = 0;
        _this.gameOverPanel = null;
        _this.playing = false;
        _this.bulletCount = 0;
        _this.maxBulletCount = 10;
        _this.bulletRevertSpeed = 1;
        _this.bulletCountLabel = null;
        _this.bulletProgress = null;
        _this.score = 0;
        _this.scoreLabel = null;
        _this.scoreLabelInGameOver = null;
        _this.help1Label = null;
        _this.helpHitEmptyLabel = null;
        _this.helpNoBulletLabel = null;
        return _this;
    }
    Scene.prototype.start = function () {
        cc.director.getCollisionManager().enabled = true;
        this.node.on(cc.Node.EventType.TOUCH_START, this.onTouchScreen, this);
        this.gameOverPanel.width = this.node.width;
        this.gameOverPanel.height = this.node.height;
        this.initAndStartGame();
        this.node.on(cc.Node.EventType.TOUCH_START, function (event) {
            // console.log('paletteNode touch start');
            this.onTouchBegan(event);
        }, this);
        this.node.on(cc.Node.EventType.TOUCH_MOVE, function (event) {
            // console.log('paletteNode touch start');
            this.onTouchMove(event);
        }, this);
        this.node.on(cc.Node.EventType.TOUCH_END, function (event) {
            // console.log('paletteNode touch start');
            this.onTouchEnd(event);
        }, this);
        // cc.eventManager.addListener({
        //     event: cc.EventListener.TOUCH_ALL_AT_ONCE,
        //     onTouchesBegan: function (touches, event) {
        //
        //         // for(let i = 0; i < touches.length; i++){
        //         //     var pos = new cc.Node("touch" + i)
        //         //     var text = pos.addComponent(cc.Label);
        //         //     text.string = "X = " + touches[i].getLocation().x.toFixed(2) + "---Y = " + touches[i].getLocation().y.toFixed(2);
        //         //     text.fontSize = 30;
        //         //     pos.setPosition(0, 0);
        //         //     cc.find("Canvas/layout").addChild(pos);
        //             console.log('touchBegin',touches);
        //         // }
        //         return true;
        //     },
        //     onTouchesMoved: function (touches, event) {
        //         console.log('touchMove',touches);
        //     }
        // }, self.node);
    };
    Scene.prototype.initAndStartGame = function () {
        this.windowSize = cc.winSize; //推荐  原因  短
        cc.log("width=" + this.windowSize.width + ",height=" + this.windowSize.height);
        // this.round.runAction(cc.fadeOut(0.01));
        this.gameOverPanel.x = 10000;
        for (var index = 0; index < this.airplaneList.length; index++) {
            var element = this.airplaneList[index];
            element.node.destroy();
        }
        this.airplaneList = [];
        this.playing = true;
        this.bulletCount = this.maxBulletCount;
        this.score = 0;
        this.scoreLabel.string = this.score + "分";
        this.help1Label.x = 0;
        this.helpHitEmptyLabel.x = 10000;
        this.helpNoBulletLabel.x = 10000;
        // this.pointX = 0;
        // this.pointY = 0;
        this.touchBeginB = false;
        this.schedule(function () {
            // 这里的 this 指向 component
            console.log('定时器');
            var airplaneNode = cc.instantiate(this.AirplanePrefab);
            airplaneNode.setParent(this.sky);
            airplaneNode.setPosition(Math.random() * (this.sky.width - airplaneNode.width) - (this.sky.width - airplaneNode.width) / 2, this.sky.height / 2);
            this.airplaneList.push(airplaneNode.getComponent(Airplane_1.default));
        }, 2);
        // // 以秒为单位的时间间隔
        // var interval = 5;
        // // 重复次数
        // var repeat = 3;
        // // 开始延时
        // var delay = 10;
        // component.schedule(function() {
        //     // 这里的 this 指向 component
        //     this.doSomething();
        // }, interval, repeat, delay);
    };
    ;
    Scene.prototype.onTouchBegan = function (event) {
        console.log('touchBegin', event);
        var touch = event.touch;
        var _pointPos = touch.getLocation();
        var pointPos = this.node.convertToNodeSpaceAR(_pointPos);
        // console.log('坐标',pointPos);
        this.touchBeginB = true;
        // this.round.stopAction();
        // cc.log("width="+this.windowSize.width+",height="+this.windowSize.height);
        // console.log('移动',this.round.getContentSize(),'位置',this.round.getPosition());
        this._pointPos = pointPos;
        this.round.stopAction();
        this.round.runAction(cc.fadeIn(0.1));
        this.round.setPosition(pointPos.x, pointPos.y);
    };
    ;
    Scene.prototype.onTouchMove = function (event) {
        console.log('onTouchMove', event);
        var touch = event.touch;
        var _pointPos = touch.getLocation();
        var pointPos = this.node.convertToNodeSpaceAR(_pointPos);
        // console.log('坐标',pointPos);
        // this.round.stopAction();
        // cc.log("width="+this.windowSize.width+",height="+this.windowSize.height);
        // console.log('移动',this.round.getContentSize(),'位置',this.round.getPosition());
        this._pointPos = pointPos;
        this.round.setPosition(pointPos.x, pointPos.y);
    };
    ;
    Scene.prototype.onTouchEnd = function (event) {
        console.log('onTouchEnd', event);
    };
    ;
    Scene.prototype.gameOver = function () {
        this.gameOverPanel.x = 0;
        this.playing = false;
        this.scoreLabelInGameOver.string = this.score + "分";
        this.helpHitEmptyLabel.x = 10000;
        this.helpNoBulletLabel.x = 10000;
    };
    ;
    Scene.prototype.update = function (dt) {
        if (this.playing) {
            this.airAddTime += dt;
            if (this.airAddTime > this.airplaneAddSpeed) {
                // let airplaneNode = cc.instantiate(this.AirplanePrefab);
                // airplaneNode.setParent(this.sky);
                // airplaneNode.setPosition(
                //     Math.random() * (this.sky.width - airplaneNode.width) - (this.sky.width - airplaneNode.width)/2,
                //     this.sky.height/2
                // );
                // this.airplaneList.push(airplaneNode.getComponent(Airplane));
                this.airAddTime = 0;
            }
            for (var index = 0; index < this.airplaneList.length; index++) {
                var element = this.airplaneList[index];
                element.node.y -= dt * 0.5 * this.airplaneMoveSpeed;
                // console.log('移动',element.node.y,'dt',dt);
                if (element.node.y < -(this.sky.height - element.node.height) / 2) {
                    // this.gameOver();
                    element.node.destroy();
                    this.airplaneList.splice(index, 1);
                }
            }
            this.bullet.rotation += dt * this.bulletRotationSpeed * this.bulletDirection;
            if ((this.bulletDirection > 0 && this.bullet.rotation > this.bulletRotationMax / 2)
                ||
                    (this.bulletDirection < 0 && this.bullet.rotation < -this.bulletRotationMax / 2)) {
                this.bulletDirection = -this.bulletDirection;
            }
            // 移除一个
            // for (let index = 0; index < this.airplaneList.length; index++) {
            //     const element = this.airplaneList[index];
            //     if (element.willDestroy) {
            //         element.node.destroy();
            //         this.airplaneList.splice(index, 1);
            //         break;
            //     }
            // }
            this.bulletCount = Math.min(this.maxBulletCount, this.bulletCount + dt * this.bulletRevertSpeed);
            this.bulletCountLabel.string = Math.floor(this.bulletCount);
            this.bulletProgress.progress = this.bulletCount / this.maxBulletCount;
            if (this.bulletCount >= 1) {
                this.bullet.color = cc.color(41, 255, 0);
                this.helpNoBulletLabel.x = 10000;
            }
            else {
                this.bullet.color = cc.color(150, 150, 150);
                this.helpNoBulletLabel.x = 0;
            }
        }
    };
    ;
    Scene.prototype.onClick = function () {
        console.log('点击');
        if (this.touchBeginB) {
            this.touchBeginB = false;
            // var _point = this._pointPos.x-200,this._pointPos.y;
            this.round.runAction(cc.fadeOut(0.1));
            for (var index = 0; index < this.airplaneList.length; index++) {
                var element = this.airplaneList[index];
                var dist = element.node.getPosition().sub(cc.v2(this._pointPos.x, this._pointPos.y)).mag();
                if (dist < 200) {
                    console.log("点击位置", this._pointPos, '飞机位置', element.node.getPosition(), 'dist', dist);
                }
                if (dist < 40) {
                    //播放动画
                    // var po = element.node.getPosition();
                    // var blowup = cc.instantiate(this.blowupani);
                    // this.node.parent.addChild(blowup);
                    // blowup.setPosition(po);
                    // var animation = blowup.getComponent(cc.Animation);
                    // animation.on('finished',  this.onFinished, blowup);
                    this.enemy = element;
                    //播放动画
                    var anim = element.node.getComponent(cc.Animation);
                    var animName = 'enemy';
                    anim.play(animName);
                    anim.on('finished', this.onFinished, this);
                    // element.node.destroy();
                    this.airplaneList.splice(index, 1);
                    this.score++;
                    this.scoreLabel.string = this.score + "分";
                    break;
                }
            }
        }
    };
    ;
    Scene.prototype.onTouchScreen = function (event) {
        console.log('event', event);
        var touch = event.touch;
        var _pointPos = touch.getLocation();
        var pointPos = this.node.convertToNodeSpaceAR(_pointPos);
        console.log('坐标', pointPos);
        // this.round.stopAction();
        cc.log("width=" + this.windowSize.width + ",height=" + this.windowSize.height);
        console.log('移动', this.round.getContentSize(), '位置', this.round.getPosition());
        // this.round.setPosition(pointPos);
        // this.pointX = pointPos.x;
        // this.pointY = pointPos.y;
        // this.pointPos = pointPos;
        // this.round.stopAction();
        // var actionA = cc.fadeIn(0.05);
        // var actionB = cc.scaleTo(0.05,6);
        // var actionC = cc.moveTo(0.1,0,0);
        // var delay = cc.delayTime(0.2);
        // var actionD = cc.fadeOut(0.15);
        // var actionE = cc.moveTo(0.01,424,-371);
        // var actionF = cc.scaleTo(0.01,1);
        // var callBack = cc.callFunc(this.callBack,this);
        // var seq = cc.sequence(actionA,actionB,actionC,delay,actionD,actionE,actionF,callBack);
        // this.round.runAction(seq);
        // if (this.bulletCount >= 1) {
        //     let empty = true;
        //     for (let index = 0; index < this.airplaneList.length; index++) {
        //         const element = this.airplaneList[index];
        //         if (element.focusing) {
        //             element.willDestroy = true;
        //             empty = false;
        //             this.score ++;
        //             this.scoreLabel.string = this.score + "分";
        //             this.help1Label.x = 10000;
        //         }
        //     }
        //     if (empty && this.bulletCount >= 2 && this.score > 0) {
        //         // 如果打空了，消耗2个子弹
        //         this.bulletCount -= 2;
        //         if (this.bulletCount >= 1) {
        //             this.helpHitEmptyLabel.x = 0;
        //         }
        //     } else if (this.score > 0) {
        //         // 没打空，消耗一个子弹
        //         this.bulletCount -= 1;
        //         this.helpHitEmptyLabel.x = 10000;
        //     }
        // }
    };
    ;
    Scene.prototype.callBack = function () {
        // let zhunxinNode = cc.instantiate(this.zhunxinPrefab);
        // zhunxinNode.setParent(this.sky);
        // zhunxinNode.setPosition(this.pointPos.x,this.pointPos.y-10);
        // this.schedule(function() {
        // zhunxinNode.destroy();
        for (var index = 0; index < this.airplaneList.length; index++) {
            var element = this.airplaneList[index];
            var dist = element.node.getPosition().sub(this.pointPos).mag();
            console.log("点击位置", this.pointPos, '飞机位置', element.node.getPosition(), 'dist', dist);
            if (dist < 40) {
                //播放动画
                // var po = element.node.getPosition();
                // var blowup = cc.instantiate(this.blowupani);
                // this.node.parent.addChild(blowup);
                // blowup.setPosition(po);
                // var animation = blowup.getComponent(cc.Animation);
                // animation.on('finished',  this.onFinished, blowup);
                this.enemy = element;
                //播放动画
                var anim = element.node.getComponent(cc.Animation);
                var animName = 'enemy';
                anim.play(animName);
                anim.on('finished', this.onFinished, this);
                // element.node.destroy();
                this.airplaneList.splice(index, 1);
                this.score++;
                this.scoreLabel.string = this.score + "分";
                break;
            }
        }
    };
    ;
    //动画结束后 动画节点回收
    Scene.prototype.onFinished = function (event) {
        console.log('销毁', event);
        this.enemy.node.destroy();
    };
    ;
    __decorate([
        property(cc.Prefab)
    ], Scene.prototype, "AirplanePrefab", void 0);
    __decorate([
        property(cc.Prefab)
    ], Scene.prototype, "zhunxinPrefab", void 0);
    __decorate([
        property(cc.Node)
    ], Scene.prototype, "sky", void 0);
    __decorate([
        property(cc.Node)
    ], Scene.prototype, "bullet", void 0);
    __decorate([
        property(cc.Node)
    ], Scene.prototype, "round", void 0);
    __decorate([
        property(Number)
    ], Scene.prototype, "bulletRotationSpeed", void 0);
    __decorate([
        property(Number)
    ], Scene.prototype, "bulletRotationMax", void 0);
    __decorate([
        property(Number)
    ], Scene.prototype, "airplaneMoveSpeed", void 0);
    __decorate([
        property(Number)
    ], Scene.prototype, "airplaneAddSpeed", void 0);
    __decorate([
        property(cc.Node)
    ], Scene.prototype, "gameOverPanel", void 0);
    __decorate([
        property(Number)
    ], Scene.prototype, "bulletRevertSpeed", void 0);
    __decorate([
        property(cc.Label)
    ], Scene.prototype, "bulletCountLabel", void 0);
    __decorate([
        property(cc.ProgressBar)
    ], Scene.prototype, "bulletProgress", void 0);
    __decorate([
        property(cc.Label)
    ], Scene.prototype, "scoreLabel", void 0);
    __decorate([
        property(cc.Label)
    ], Scene.prototype, "scoreLabelInGameOver", void 0);
    __decorate([
        property(cc.Node)
    ], Scene.prototype, "help1Label", void 0);
    __decorate([
        property(cc.Node)
    ], Scene.prototype, "helpHitEmptyLabel", void 0);
    __decorate([
        property(cc.Node)
    ], Scene.prototype, "helpNoBulletLabel", void 0);
    Scene = __decorate([
        ccclass
    ], Scene);
    return Scene;
}(cc.Component));
exports.default = Scene;

cc._RF.pop();
        }
        if (CC_EDITOR) {
            __define(__module.exports, __require, __module);
        }
        else {
            cc.registerModuleFunc(__filename, function () {
                __define(__module.exports, __require, __module);
            });
        }
        })();
        //# sourceMappingURL=Scene.js.map
        